# Continous Intergration Continous Delivery and Deployment

We chose AWS to host our project

Intergration:
GitLab 


## Tech-stack 
- AWS
  - **RDS** postgresql database
  - **S3** bucket for host html
  - **EC3** to host/run docker and project
    - inderectly connects to the RDS
    - set up required a security 
    - Ports used
      - 8080 for jenkins
      - 8082 for docker/our API
    - group:
      - inbound rules
      - outbound rules 
- **Jenkins**
  - used to automate the process of:
    - fetching git repository
    - utilize maven to build the package (sans test)
    - removed any previously generated images
    - create a new image based on the given Dockerfile (in the chosen repo)
    - stop any previously generated containers
    - then finally run the newly created container with the correct credentials and port location

Additional Features: a web hook was set up to auto-start jenkins based on changes to the main gitlab repository

Docker: runs the given jar file of our spring boot project:




Time line: 23-26


the game starts of 3 choic

The game loads with the game board, their level(one), their current balance(global) and their current wager(zero)

The player must first pick a hand to start the game.

Once they pick the card, they are to enter a starting bet.

This bet must be a valid number (cant be below zero), and cannot bet over the user's balance.

Once they input their number, they can either clear their choice or submit.

One their submit they have a 33% chance of winning and 66% of losing on the first level.

If they win then they are prompted with the option to either Cashout or continue:
  Cashout: their wager is added to their balance and the game ends.
  Continue: the board is reset(Not the page), their level increments and their wager is passed on.

If they get a draw (same hands) then their inputed bet is subtracted from their wager:
  if the wager drops below zero then the game is over (follows the same logic as losing)
  otherwise they have the option to continue or quit. (Cashout for winners only)

If they lose then their wager(which contains their bets) are automatically withdrawn from their account balance and the game is over.

---

Continues intergration, delivery and deployment

have to enable virtualization 